%{
#include "y.tab.h"
#include "phones.h"

int LineNo = 1;
char StringTable[200000], *StringTop = StringTable;
char *UniqueStrings[200], **UniqueTop = UniqueStrings;
char *storestring();
char *storeunique();

%}
%start NAM NUM CHKNUM ADDR COMM KY DEFKY
%%
<CHKNAM>\t	lexerror("expected name; found tab");
<CHKNAM>\(	lexerror("expected name; found comment");
<CHKNAM>\n	LineNo++;
<CHKNAM>@	BEGIN DEFKY;
<CHKNAM>^%.*$	;			/* ignore lines starting with a % */
<CHKNAM>.	{ BEGIN NAM; yymore(); }

<DEFKY>.*$	{ yylval.s = storeunique(); BEGIN CHKNAM; return DEFAULT_KEY; }

<NAM>[^ \t\n]+	{ yylval.s = storestring(); return NAME; }
<NAM>[ ]	;				/* spaces are separators */
<NAM>[\t]	BEGIN NUM;			/* tabs are meaningful */
<NAM>\n		lexerror("phone expected");

<NUM>\t		;				/* ignore tabs */
<NUM>.*$	{ yylval.s = storestring(); return TELNO; }
<NUM>\n		{ BEGIN CHKNUM; LineNo++; }

<CHKNUM>\n	{ BEGIN NAM; LineNo++; }
<CHKNUM>^@	{ BEGIN KY; }
<CHKNUM>\(	{ BEGIN COMM; }
<CHKNUM>\t	{ BEGIN NUM; }
<CHKNUM>[^\t]	{ BEGIN ADDR; yymore(); }

<ADDR>[^\n]+	{ yylval.s = storestring(); return ADDRESS; }
<ADDR>\n	{ LineNo++; BEGIN CHKADDR; }

<CHKADDR>\(	{ BEGIN COMM; }
<CHKADDR>@	{ BEGIN KY; }
<CHKADDR>\n	{ BEGIN NAM; LineNo++; }
<CHKADDR>.	{ BEGIN ADDR; yymore(); }

<COMM>[^)\n]+	{ yylval.s = storestring(); return COMMENT; }
<COMM>\n	LineNo++;
<COMM>\)	{ BEGIN CHKKY; }

<CHKKY>@	{ BEGIN KY; }
<CHKKY>\n	{ BEGIN CHKNAM; LineNo++; }
<CHKKY>.	{ lexerror("key or end of entry expected"); }

<KY>[^ \n]*	{ yylval.s = storeunique(); return KEY; }
<KY>\n\n	{ BEGIN CHKNAM; LineNo += 2}
<KY>\n		{ lexerror("blank line expected after keys"); }

.		yyerror();		/* anything else is error */
%%

#include <stdio.h>

lexinit()
{
    BEGIN NAM;
}

yyerror()
{
	fprintf(stderr, "error at line %d reading ``%s''\n", LineNo, yytext);
	exit (1);
}

char *
storestring()
{
	register char *to = StringTop, *from = yytext, *start = StringTop;

	while (*to++ = *from++);
	StringTop = to;
	if (StringTop >= StringTable + sizeof(StringTable)) {
		fprintf(stderr, "string table overflow\n");
		exit(1);
	}
	return start;
}

char *storeunique()
{
    char **p = UniqueStrings;
    char *s;
    if (yytext[0] = '\0') return (char *) 0;
    while (p < UniqueTop) {
	if (! strcmp(yytext, *p) ) return *p;
	p++;
    }
    s = storestring();
    *p = s;
    UniqueTop++;
    if (UniqueTop >
	UniqueStrings + sizeof(UniqueStrings) / sizeof(UniqueStrings[0])) {
	fprintf(stderr, "key table overflow\n");
	exit(1);
    }
    return s;
}
