%{
#include "y.tab.h"
#include "phones.h"

int LineNo = 1;
char StringTable[200000], *StringTop = StringTable;
char *UniqueStrings[200], **UniqueTop = UniqueStrings;
char *storestring();
char *storeunique();

%}
%start NAM NUM CHKNUM ADDR COMM KY DEFKY
%%
<NAM>^@		BEGIN DEFKY;
<DEFKY>.*$	{ yylval.s = storeunique(); return DEFAULT_KEY; BEGIN NAM; }

<NAM>[^ \t]+	{ yylval.s = storestring(); return NAME; }
<NAM>[ ]	;				/* spaces are separators */
<NAM>[\t]	BEGIN NUM;			/* tabs are meaningful */

<NUM>\t		;				/* ignore tabs */
<NUM>.*$	{ yylval.s = storestring(); return TELNO; }
<NUM>\n		{ BEGIN CHKNUM; LineNo++; }
<NUM>^@		{ BEGIN KY; }
<NUM>^\(	{ BEGIN COMM; }

<CHKNUM>\n	{ BEGIN NAM; LineNo++; }
<CHKNUM>[^\t]	{ BEGIN ADDR; yymore(); }
<CHKNUM>\t	{ BEGIN NUM; }

<ADDR>\n	LineNo++;
<ADDR>^\(	{ BEGIN COMM; }
<ADDR>^@	{ BEGIN KY; }
<ADDR>^\n	{ BEGIN NAM; LineNo++; }
<ADDR>^.*$	{ yylval.s = storestring(); return ADDRESS; }

<COMM>[^)\n]+	{ yylval.s = storestring(); return COMMENT; }
<COMM>\n	LineNo++;
<COMM>\)	{ BEGIN CHKY

<CHKY>^@	{ BEGIN KY; }

<KY>@{L}+	{ yylval.s = storeunique(); return KEY; }
<KY>\n		{ LineNo++; BEGIN NAM; }

^%.*$		;			/* ignore lines starting with a % */
.		yyerror();		/* anything else is error */
%%

#include <stdio.h>

lexinit()
{
    BEGIN NAM;
}

yyerror()
{
	fprintf(stderr, "error at line %d reading ``%s''\n", LineNo, yytext);
	exit (1);
}

char *
storestring()
{
	register char *to = StringTop, *from = yytext, *start = StringTop;

	while (*to++ = *from++);
	StringTop = to;
	if (StringTop >= StringTable + sizeof(StringTable)) {
		fprintf(stderr, "string table overflow\n");
		exit(1);
	}
	return start;
}

char *storeunique()
{
    char **p = UniqueStrings;
    char *s;
    if (yytext[0] = '\0') return (char *) 0;
    while (p < UniqueTop) {
	if (! strcmp(yytext, *p) ) return *p;
	p++;
    }
    s = storestring();
    *p = s;
    UniqueTop++;
    if (UniqueTop >
	UniqueStrings + sizeof(UniqueStrings) / sizeof(UniqueStrings[0])) {
	fprintf(stderr, "key table overflow\n");
	exit(1);
    }
    return s;
}
