%{
/*
    phoneformat - produce a compact TeX file for a simple address database.
    Copyright (C) 1989-1994  Luigi Semenzato

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Author's address:
    Computer Science Division
    University of California
    Berkeley, CA 94720
    luigi@cs.berkeley.edu

    This program was developed in the author's own time
    and is not connected in any way to the author's research
    at Berkeley.
*/
#include "phones.h"
%}
%token NAME TELNO ADDRESS COMMENT KEY DEFAULT_KEY
%%
phonebook:
	  entry			{ CE++; }
	| phonebook entry	{ CE++; }
	;

entry:
	  default.key name.list telno.list address.list comment.list key.list
	  { CE->sortname = lastname;
	    CE->names = $2.l;
	    CE->telnos = $3.l;
	    CE->address = $4.l;
	    CE->comment = $5.l;
	    CE->keys = defaultKey ? stringcons(defaultKey, $6.l) : $6.l; }
	;

name.list:
	  NAME			{ $$.l = lastname = stringcons($1.s, NULLS); }
	| NAME name.list	{ $$.l = stringcons($1.s, $2.l); }
	;

telno.list:
	  TELNO			{ $$.l = stringcons($1.s, NULLS); }
	| TELNO telno.list	{ $$.l = stringcons($1.s, $2.l); }
	;

address.list:
	  /* empty */		{ $$.l = NULLS; }
	| ADDRESS address.list	{ $$.l = stringcons($1.s, $2.l); }
	;

comment.list:
	  /* empty */		{ $$.l = NULLS; }
	| COMMENT comment.list  { $$.l = stringcons($1.s, $2.l); }
	;

key.list:
	  /* empty */		{ $$.l = NULLS; }
	| KEY key.list		{ $$.l = stringcons($1.s, $2.l); }
	;

default.key:
	  /* empty */
	| DEFAULT_KEY		{ defaultKey = $1.s; }
  	;
